%define build_modules   1
%{?_with_modules: %global build_modules 1}

%define enable_jasper   1
%{?_with_jasper: %global enable_jasper 1}

%define enable_graphwiz 1
%{?_with_graphwiz: %global enable_graphwiz 1}

%define Name            GraphicsMagick
%define libname         %mklibname %name 3
%define libwandname     %mklibname graphicsmagickwand 2
%define develname       %mklibname %name -d
%define qlev            Q8

Summary:        An X application for displaying and manipulating images
Name:           graphicsmagick
Version:        1.3.20
Release:        %mkrel 4
License:        GPLv2+
Group:          Graphics/Editors and Converters
URL:            http://www.graphicsmagick.org/
Source0:        http://downloads.sourceforge.net/%{name}/%{Name}-%{version}.tar.xz
Patch0:         GraphicsMagick-1.3.15-use-so-for-modules.patch
Patch1:         GraphicsMagick-1.3.16-perl-link.patch
Patch2:		GraphicsMagick-1.3.20-CVE-2014-1947.patch
Patch3:		graphicsmagick-1.3.20-CVE-2014-8355.patch
BuildRequires:  x11-proto-devel
BuildRequires:  perl-devel
BuildRequires:  freetype2-devel
BuildRequires:  tiff-devel
BuildRequires:  png-devel
BuildRequires:  jpeg-devel
BuildRequires:  jasper-devel
BuildRequires:  libwmf-devel
BuildRequires:  zlib-devel
BuildRequires:  bzip2-devel
BuildRequires:  libxml2-devel
BuildRequires:  lcms-devel
BuildRequires:  lcms2-devel
BuildRequires:  libgs-devel
BuildRequires:  libtool-devel
BuildRequires:  jbigkit-devel
BuildRequires:	chrpath

%description
GraphicsMagick is the swiss army knife of image processing. It 
provides a robust collection of tools and libraries which support 
reading, writing, and manipulating an image in over 88 major formats 
including important formats like DPX, GIF, JPEG, JPEG-2000, PNG, PDF, 
SVG, and TIFF. GraphicsMagick supports huge images on systems that 
support large files, and has been tested with gigapixel-size images. 
GraphicsMagick can create new images on the fly, making it suitable 
for building dynamic Web applications. GraphicsMagick may be used to 
resize, rotate, sharpen, color reduce, or add special effects to an 
image and save the result in the same or differing image format. 
Image processing operations are available from the command line, as 
well as through C, C++, Perl, or Windows COM programming interfaces. 
Extensions are available from third-parties to support programming in 
Python, Tcl, and Ruby. With some modification, language extensions for 
ImageMagick may be used.

%files
%doc ChangeLog *.txt
%{_bindir}/gm
%dir %{_libdir}/GraphicsMagick-%{version}/config
%{_libdir}/GraphicsMagick-%{version}/config/*.mgk
%dir %{_datadir}/GraphicsMagick-%{version}/config
%{_datadir}/GraphicsMagick-%{version}/config/*.mgk
%if %build_modules
%dir %{_libdir}/%{Name}-%{version}/modules-%{qlev}
%{_libdir}/%{Name}-%{version}/modules-%{qlev}/filters
%dir %{_libdir}/%{Name}-%{version}/modules-%{qlev}/coders
%{_libdir}/%{Name}-%{version}/modules-%{qlev}/coders/*.so
%endif
%{_mandir}/man1/GraphicsMagick++-config.1.*
%{_mandir}/man1/GraphicsMagick-config.1.*
%{_mandir}/man1/GraphicsMagickWand-config.1.*
%{_mandir}/man1/gm.1.*
%{_mandir}/man4/miff.4.*
%{_mandir}/man5/quantize.5.*

#--------------------------------------------------------------

%package -n     %{libname}
Summary:        %Name libraries
Group:          System/Libraries

%description -n %{libname}
This package contains the libraries needed to run programs dynamically
linked with GraphicsMagick libraries.

%files -n %{libname}
%{_libdir}/libGraphicsMagick++.so.3*
%{_libdir}/libGraphicsMagick.so.3*

#--------------------------------------------------------------

%package -n     %{libwandname}
Summary:        %Name libraries
Group:          System/Libraries

%description -n %{libwandname}
This package contains the libraries needed to run programs dynamically
linked with GraphicsMagick libraries.

%files -n %{libwandname}
%{_libdir}/libGraphicsMagickWand.so.2*

#--------------------------------------------------------------

%package -n     %{develname}
Summary:        Static libraries and header files for %{Name} app development
Group:          Development/C
Provides:       %{name}-devel = %{version}-%{release}
Provides:       %{Name}-devel = %{version}-%{release}
Obsoletes:      %mklibname -d graphicsmagick 1.1.10
Requires:       %{libname} = %{version}
Requires:       %{libwandname} = %{version}
Requires:       jbig-devel
%if %{enable_jasper}
Requires:       jasper-devel
%endif
%if %{enable_graphwiz}
Requires:       graphviz-devel
%global __requires_exclude devel\\(libcdt\\)|devel\\(libcircogen\\)|devel\\(libcommon\\)|devel\\(libdotgen\\)|devel\\(libdotneato\\)|devel\\(libfdpgen\\)|devel\\(libgraph\\)|devel\\(libgvrender\\)|devel\\(libneatogen\\)|devel\\(libpack\\)|devel\\(libpathplan\\)|devel\\(libtwopigen\\)|devel\\(libgvc\\)|devel\\(libgvgd\\)
%endif

%description -n %{develname}
If you want to create applications that will use GraphicsMagick code or
APIs, you'll need to install these packages as well as
GraphicsMagick. These additional packages aren't necessary if you simply
want to use GraphicsMagick, however.

graphicsmagick-devel is an addition to GraphicsMagick which includes static
libraries and header files necessary to develop applications.

%files -n %{develname}
%{_bindir}/GraphicsMagick++-config
%{_bindir}/GraphicsMagick-config
%{_bindir}/GraphicsMagickWand-config
%dir %{_includedir}/GraphicsMagick
%{_includedir}/GraphicsMagick/Magick++.h
%dir %{_includedir}/GraphicsMagick/magick
%{_includedir}/GraphicsMagick/magick/*.h
%dir %{_includedir}/GraphicsMagick/Magick++
%{_includedir}/GraphicsMagick/Magick++/*.h
%dir %{_includedir}/GraphicsMagick/wand
%{_includedir}/GraphicsMagick/wand/*.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

#--------------------------------------------------------------

%package -n     perl-Graphics-Magick
Summary:        Libraries and modules for access to %Name from perl
Group:          Development/Perl
Requires:       %{name} = %{version}
%if %{enable_graphwiz}
Requires:       graphviz
%endif

%description -n perl-Graphics-Magick
This is the %Name perl support package. It includes perl modules
and support files for access to GraphicsMagick library from perl.

%files -n perl-Graphics-Magick
%{_mandir}/man3*/*::*.3pm*
%{perl_vendorarch}/Graphics
%{perl_vendorarch}/auto

#--------------------------------------------------------------

%package        doc
Summary:        %{name} Documentation
Group:          Documentation
BuildArch:      noarch

%description    doc
This package contains HTML/PDF documentation of %{name}.

%files doc
%{_datadir}/doc/GraphicsMagick

#--------------------------------------------------------------

%prep
%setup -q -n %{Name}-%{version}
%patch0 -p0
%patch1 -p1 -b .perl-link
%patch2 -p1 -b .CVE-2014-1947
%patch3 -p1 -b .CVE-2014-8355

%build
%define Werror_cflags %nil
%configure2_5x \
    --enable-fast-install \
    --without-dps \
%if %{build_modules}
    --with-modules \
%else
    --without-modules \
%endif
    --enable-shared \
    --disable-static \
    --with-pic \
%if %{enable_jasper}
    --with-jp2 \
%else
    --without-jp2 \
%endif
    --with-perl-options="INSTALLDIRS=vendor"  \
    --with-perl

%make
%make perl-build

%install
%makeinstall_std
%makeinstall_std -C PerlMagick

# fix rights and remove rpaths
chmod 755 %{buildroot}%{perl_vendorarch}/auto/Graphics/Magick/Magick.so
chrpath -d %{buildroot}%{perl_vendorarch}/auto/Graphics/Magick/Magick.so

# remove unwanted files
find %{buildroot} -name '*.la' -delete
rm -f %{buildroot}%{_datadir}/GraphicsMagick-%{version}/{ChangeLog,NEWS.txt}


%changelog
* Fri Nov 14 2014 luigiwalser <luigiwalser> 1.3.20-4.mga5
+ Revision: 796898
- add upstream patch to fix CVE-2014-8355

* Wed Oct 15 2014 umeabot <umeabot> 1.3.20-3.mga5
+ Revision: 746200
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.3.20-2.mga5
+ Revision: 679929
- Mageia 5 Mass Rebuild

  + tv <tv>
    - use %%global for req/prov exclude
    - autoconvert to new prov/req excludes

* Fri Aug 29 2014 luigiwalser <luigiwalser> 1.3.20-1.mga5
+ Revision: 669268
- 1.3.20
- add patch from fedora to fix CVE-2014-1947

* Sun Aug 17 2014 wally <wally> 1.3.19-1.mga5
+ Revision: 664839
- rediff perl module linking patch to fix build
- drop rpath from perl module

  + spuhler <spuhler>
    - upgrade to ver. 1.3.19
    - removed invalid config option --disable-ltdl-install

  + pterjan <pterjan>
    - Rebuild for perl 5.20

* Sat Oct 19 2013 umeabot <umeabot> 1.3.18-3.mga4
+ Revision: 526031
- Mageia 4 Mass Rebuild

  + akien <akien>
    - Fixed description references to ImageMagick instead of GraphicsMagick
    - Cleaned spec file (inconsistant use of tabs and spaces)

* Mon Jun 03 2013 fwang <fwang> 1.3.18-2.mga4
+ Revision: 435527
- rebuild for new libpng

* Wed May 29 2013 fwang <fwang> 1.3.18-1.mga4
+ Revision: 430311
- new version 1.3.18

* Sat Jan 12 2013 umeabot <umeabot> 1.3.17-2.mga3
+ Revision: 352565
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

  + boklm <boklm>
    - Update group: Graphics/Editors -> Graphics/Editors and Converters

* Tue Oct 16 2012 fwang <fwang> 1.3.17-1.mga3
+ Revision: 307089
- br ltdl
- drop merged patch
- update rpm group
- new version 1.3.17

* Sat Sep 08 2012 luigiwalser <luigiwalser> 1.3.16-4.mga3
+ Revision: 289832
- add upstream patch to fix CVE-2012-3438

* Wed Aug 01 2012 blino <blino> 1.3.16-3.mga3
+ Revision: 276909
- really link perl module with library

* Mon Jul 09 2012 fwang <fwang> 1.3.16-2.mga3
+ Revision: 269011
- update lcms2

* Mon Jun 25 2012 fwang <fwang> 1.3.16-1.mga3
+ Revision: 263388
- new version 1.3.16

* Thu Jun 14 2012 fwang <fwang> 1.3.15-3.mga3
+ Revision: 260526
- fix bug#6411: graphicsmagick knows nothing about modules

* Sat Jun 02 2012 blino <blino> 1.3.15-2.mga3
+ Revision: 253383
- fail if typemap already exists (to remove the hack when upstream is fixed)

* Sat Jun 02 2012 blino <blino> 1.3.15-1.mga3
+ Revision: 253364
- Add a  simple "ignore this type" style typemap to get past a xsubpp
  exception in recent versions of Perl, from ImageMagick r4950
  (see also rt #70150, gentoo #378197)

  + fwang <fwang>
    - new version 1.3.15
    - rebuild for new perl
    - set doc as noarch

* Fri Jan 13 2012 fwang <fwang> 1.3.13-1.mga2
+ Revision: 195719
- new version 1.3.13

* Fri Dec 23 2011 fwang <fwang> 1.3.12-6.mga2
+ Revision: 186520
- rebuild for new libtiff

* Wed Sep 14 2011 fwang <fwang> 1.3.12-5.mga2
+ Revision: 143446
- update file list
- add gentoo patches to fix build with latest libpng
- drop .la files

* Sun Jun 12 2011 sander85 <sander85> 1.3.12-4.mga2
+ Revision: 104629
- Rebuild for perl 5.14

* Sun Feb 06 2011 spuhler <spuhler> 1.3.12-3.mga1
+ Revision: 47953
- removed the if mdkversion lines  from spec
- imported package graphicsmagick

